Search results

Add new row position while adding in JavaScript (ES5) Gantt control

06 Jun 2023 / 2 minutes to read

In Gantt, a new row can be added in one of the following positions: Top, Bottom, Above, Below and Child. This position can be specified through the newRowPostion property. We can make use of the toolbarClick event to create a context menu that specifies the position in which the new row is to be added when adding a record through toolbar click.

The following code snippets demonstrate how to achieve this.

Source
Preview
index.js
index.html
Copied to clipboard
var clickHandler = function(args){
	if (args.item.id === 'GanttExport_add') {
			 var contextMenuObj = document.getElementById("contextmenu").ej2_instances[0];
             contextMenuObj.open(60, 20);
		}
};
ej.gantt.Gantt.Inject(ej.gantt.Toolbar);
var menuItems = [
    {
        text: 'Bottom'
    },
    {
        text: 'Above'
    },
    {
        text: 'Below'
    },
    {
        text: 'Child'
    },
    {
        text: 'Top'
    }];
var menuOptions = {
        items: menuItems,
        select: select
    };

var menuObj = new ej.navigations.ContextMenu(menuOptions, '#contextmenu');

function select(args: any) {
  let gantt: any = (document.getElementsByClassName('e-gantt')[0] as any).ej2_instances[0];
  if (args.item.text === "Bottom") {
    gantt.editSettings.newRowPosition = "Bottom";
    gantt.openAddDialog();
  } else if (args.item.text === "Above") {
    if (gantt.selectedRowIndex == -1) {
      alert("Please select any row");
    } else {
      gantt.editSettings.newRowPosition = "Above";
      gantt.openAddDialog();
    }
  } else if (args.item.text === "Below") {
    if (gantt.selectedRowIndex == -1) {
      alert("Please select any row");
    } else {
      gantt.editSettings.newRowPosition = "Below";
      gantt.openAddDialog();
    }

  } else if (args.item.text === "Child") {
    if (gantt.selectedRowIndex == -1) {
      alert("Please select any row");
    } else {
      gantt.editSettings.newRowPosition = "Child";
      gantt.openAddDialog();
    }
  } else if (args.item.text === "Top") {
    gantt.editSettings.newRowPosition = "Top";
    gantt.openAddDialog();
  }
}

var ganttChart = new ej.gantt.Gantt({
        dataSource: GanttData,
		height:'450px',
		allowSelection: true,
		taskFields: {
            id: 'TaskID',
            name: 'TaskName',
            startDate: 'StartDate',
			duration: 'Duration',
            progress: 'Progress',
			child: 'subtasks'
        },
		editSettings:{
			allowAdding:true
		},
        toolbar: ['Edit', { text: 'Add', tooltipText: 'Add', id: 'Add' }],
        toolbarClick: clickHandler,

});
ganttChart.appendTo('#Gantt');
Copied to clipboard
<!DOCTYPE html><html lang="en"><head>
            
    <title>EJ2 Gantt</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Gantt Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
	<link href="https://cdn.syncfusion.com/ej2/21.2.3/material.css" rel="stylesheet" type="text/css">
    
    
<script src="https://cdn.syncfusion.com/ej2/21.2.3/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>

<body>
    
    
    <div id="container">
        <div id="Gantt"></div>
        <ul id="contextmenu"></ul>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
    ele.style.visibility = "visible";
 }   
        </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

New row position in Vue Gantt component

11 Jun 202419 minutes to read

In Gantt, a new row can be added in one of the following positions: Top, Bottom, Above, Below and Child. This position can be specified through the newRowPostion property. We can make use of the toolbarClick event to create a context menu that specifies the position in which the new row is to be added when adding a record through toolbar click.

The following code snippets demonstrate how to achieve this.

<template>
     <div>
     <ejs-contextmenu id='cmenu' :items='menuItems' :select="select"></ejs-contextmenu>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :taskFields = "taskFields" :height = "height" :toolbar="toolbar" :toolbarClick="toolbarClick" :editSettings= "editSettings"></ejs-gantt>
    </div>
</template>
<script setup>
import { provide, ref } from "vue";
import {
  GanttComponent as EjsGantt,
  Edit,
  Toolbar,
  Selection,
} from "@syncfusion/ej2-vue-gantt";
import { ContextMenuComponent as EjsContextmenu } from "@syncfusion/ej2-vue-navigations";
const gantt = ref(null);
const cmenu = ref(null);
const menuItems = [
  {
    text: "Bottom",
  },
  {
    text: "Above",
  },
  {
    text: "Below",
  },
  {
    text: "Child",
  },
  {
    text: "Top",
  },
];
const data = [
  {
    TaskID: 1,
    TaskName: "Project Initiation",
    StartDate: new Date("04/02/2019"),
    EndDate: new Date("04/21/2019"),
    subtasks: [
      {
        TaskID: 2,
        TaskName: "Identify Site location",
        StartDate: new Date("04/02/2019"),
        Duration: 4,
        Progress: 50,
      },
      {
        TaskID: 3,
        TaskName: "Perform Soil test",
        StartDate: new Date("04/02/2019"),
        Duration: 4,
        Progress: 50,
      },
      {
        TaskID: 4,
        TaskName: "Soil test approval",
        StartDate: new Date("04/02/2019"),
        Duration: 4,
        Progress: 50,
      },
    ],
  },
  {
    TaskID: 5,
    TaskName: "Project Estimation",
    StartDate: new Date("04/02/2019"),
    EndDate: new Date("04/21/2019"),
    subtasks: [
      {
        TaskID: 6,
        TaskName: "Develop floor plan for estimation",
        StartDate: new Date("04/04/2019"),
        Duration: 3,
        Progress: 50,
      },
      {
        TaskID: 7,
        TaskName: "List materials",
        StartDate: new Date("04/04/2019"),
        Duration: 3,
        Progress: 50,
      },
      {
        TaskID: 8,
        TaskName: "Estimation approval",
        StartDate: new Date("04/04/2019"),
        Duration: 3,
        Progress: 50,
      },
    ],
  },
];
const height = "450px";
const taskFields = {
  id: "TaskID",
  name: "TaskName",
  startDate: "StartDate",
  duration: "Duration",
  progress: "Progress",
  child: "subtasks",
};
const editSettings = {
  allowAdding: true,
};
const toolbar = [
  {
    text: "Add",
    tooltipText: "Add",
    id: "Add",
  }
];
const toolbarClick = (args) => {
  if (args.item.id === "Add") {
    cmenu.value.ej2Instances.open(40, 20);
  }
};
const select = function (args) {
  var ganttObj = gantt.value.ej2Instances;
  if (args.item.text === "Bottom") {
    ganttObj.editSettings.newRowPosition = "Bottom";
    ganttObj.openAddDialog();
  } else if (args.item.text === "Above") {
    if (ganttObj.selectedRowIndex === -1) {
      alert("Please select any row");
    } else {
      ganttObj.editSettings.newRowPosition = "Above";
      ganttObj.openAddDialog();
    }
  } else if (args.item.text === "Below") {
    if (ganttObj.selectedRowIndex === -1) {
      alert("Please select any row");
    } else {
      ganttObj.editSettings.newRowPosition = "Below";
      ganttObj.openAddDialog();
    }
  } else if (args.item.text === "Child") {
    if (ganttObj.selectedRowIndex === -1) {
      alert("Please select any row");
    } else {
      ganttObj.editSettings.newRowPosition = "Child";
      ganttObj.openAddDialog();
    }
  } else if (args.item.text === "Top") {
    ganttObj.editSettings.newRowPosition = "Top";
    ganttObj.openAddDialog();
  }
};
provide('gantt',  [Edit, Toolbar, Selection]);
</script>
<template>
     <div>
     <ejs-contextmenu id='cmenu' :items='menuItems' :select="select"></ejs-contextmenu>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :taskFields = "taskFields" :height = "height" :toolbar="toolbar" :toolbarClick="toolbarClick" :editSettings= "editSettings"></ejs-gantt>
    </div>
</template>
<script>

import {
  GanttComponent,
  Edit,
  Toolbar,
  Selection,
} from "@syncfusion/ej2-vue-gantt";
import { ContextMenuComponent } from "@syncfusion/ej2-vue-navigations";
export default {
name: "App",
components: {
"ejs-contextmenu":ContextMenuComponent,
"ejs-gantt":GanttComponent
},

  data: function () {
    return {
      menuItems: [
        {
          text: "Bottom",
        },
        {
          text: "Above",
        },
        {
          text: "Below",
        },
        {
          text: "Child",
        },
        {
          text: "Top",
        },
      ],
      data: [
        {
          TaskID: 1,
          TaskName: "Project Initiation",
          StartDate: new Date("04/02/2019"),
          EndDate: new Date("04/21/2019"),
          subtasks: [
            {
              TaskID: 2,
              TaskName: "Identify Site location",
              StartDate: new Date("04/02/2019"),
              Duration: 4,
              Progress: 50,
            },
            {
              TaskID: 3,
              TaskName: "Perform Soil test",
              StartDate: new Date("04/02/2019"),
              Duration: 4,
              Progress: 50,
            },
            {
              TaskID: 4,
              TaskName: "Soil test approval",
              StartDate: new Date("04/02/2019"),
              Duration: 4,
              Progress: 50,
            },
          ],
        },
        {
          TaskID: 5,
          TaskName: "Project Estimation",
          StartDate: new Date("04/02/2019"),
          EndDate: new Date("04/21/2019"),
          subtasks: [
            {
              TaskID: 6,
              TaskName: "Develop floor plan for estimation",
              StartDate: new Date("04/04/2019"),
              Duration: 3,
              Progress: 50,
            },
            {
              TaskID: 7,
              TaskName: "List materials",
              StartDate: new Date("04/04/2019"),
              Duration: 3,
              Progress: 50,
            },
            {
              TaskID: 8,
              TaskName: "Estimation approval",
              StartDate: new Date("04/04/2019"),
              Duration: 3,
              Progress: 50,
            },
          ],
        },
      ],
      height: "450px",
      taskFields: {
        id: "TaskID",
        name: "TaskName",
        startDate: "StartDate",
        duration: "Duration",
        progress: "Progress",
        child: "subtasks",
      },
      editSettings: {
        allowAdding: true,
      },
      toolbar: [
        {
          text: "Add",
          tooltipText: "Add",
          id: "Add",
        }
      ],
      toolbarClick: (args) => {
        if (args.item.id === "Add") {
          document.getElementById("cmenu").ej2_instances[0].open(40, 20);
        }
      },
    };
  },
  methods: {
    select: function (args) {
      var ganttObj = document.getElementById("GanttContainer").ej2_instances[0];
      if (args.item.text === "Bottom") {
        ganttObj.editSettings.newRowPosition = "Bottom";
        ganttObj.openAddDialog();
      } else if (args.item.text === "Above") {
        if (ganttObj.selectedRowIndex === -1) {
          alert("Please select any row");
        } else {
          ganttObj.editSettings.newRowPosition = "Above";
          ganttObj.openAddDialog();
        }
      } else if (args.item.text === "Below") {
        if (ganttObj.selectedRowIndex === -1) {
          alert("Please select any row");
        } else {
          ganttObj.editSettings.newRowPosition = "Below";
          ganttObj.openAddDialog();
        }
      } else if (args.item.text === "Child") {
        if (ganttObj.selectedRowIndex === -1) {
          alert("Please select any row");
        } else {
          ganttObj.editSettings.newRowPosition = "Child";
          ganttObj.openAddDialog();
        }
      } else if (args.item.text === "Top") {
        ganttObj.editSettings.newRowPosition = "Top";
        ganttObj.openAddDialog();
      }
    },
  },
  provide: {
    gantt: [Edit, Toolbar, Selection],
  },
};
</script>

New row position in Angular Gantt component

28 Sep 202312 minutes to read

In Gantt, a new row can be added in one of the following positions: Top, Bottom, Above, Below and Child. This position can be specified through the newRowPostion property. We can make use of the toolbarClick event to create a context menu that specifies the position in which the new row is to be added when adding a record through toolbar click.

The following code snippets demonstrate how to achieve this.

import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { ToolbarItem, EditSettingsModel, GanttComponent } from '@syncfusion/ej2-angular-gantt';
import { MenuItemModel, ContextMenu } from '@syncfusion/ej2-navigations';
import { Gantt } from '@syncfusion/ej2-gantt';
import { ClickEventArgs } from '@syncfusion/ej2-angular-navigations';

@Component({
    selector: 'app-root',
    template:`<ejs-contextmenu id='contextmenu' [items]= 'menuItems' (select)="select($event)"></ejs-contextmenu>
       <ejs-gantt id="ganttDefault" height="430px" [dataSource]="data" [taskFields]="taskSettings" [editSettings]="editSettings" [toolbar]="toolbar" (toolbarClick)="toolbarClick($event)"></ejs-gantt>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent{
    // Data for Gantt
    public data?: object[];
    public taskSettings?: object;
    public editSettings?: EditSettingsModel;
    public toolbar?: ToolbarItem[];
    @ViewChild('gantt', {static: true})
    public ganttObj?: GanttComponent| any;
    public ngOnInit(): void {
        this.data =  [
            {
                TaskID: 1,
                TaskName: 'Project Initiation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                subtasks: [
                    {  TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                    { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50  },
                    { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                ]
            },
            {
                TaskID: 5,
                TaskName: 'Project Estimation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                subtasks: [
                    { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
                    { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
                    { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 }
                ]
            },
        ];
        this.taskSettings = {
            id: 'TaskID',
            name: 'TaskName',
            startDate: 'StartDate',
            duration: 'Duration',
            progress: 'Progress',
            child: 'subtasks'
        };
        this.editSettings = {
            allowAdding:true
            };
            this.toolbar = ['Add'];
    }
    public menuItems: MenuItemModel[] = [
        {
            text: 'Bottom'
        },
        {
            text: 'Above'
        },
        {
            text: 'Below'
        },
        {
            text: 'Child'
        },
        {
            text: 'Top'
        }];
        public select(args: any) {
            if (args.item.text === "Bottom") {
            this.ganttObj.editSettings.newRowPosition = "Bottom";
            this.ganttObj.openAddDialog();
        } else if (args.item.text === "Above") {
            if (this.ganttObj.selectedRowIndex == -1) {
                alert("Please select any row");
            } else {
                this.ganttObj.editSettings.newRowPosition = "Above";
                this.ganttObj.openAddDialog();
            }
        } else if (args.item.text === "Below") {
            if (this.ganttObj.selectedRowIndex == -1) {
                alert("Please select any row");
            } else {
                this.ganttObj.editSettings.newRowPosition = "Below";
                this.ganttObj.openAddDialog();
            }
        } else if (args.item.text === "Child") {
            if (this.ganttObj.selectedRowIndex == -1) {
                alert("Please select any row");
            } else {
                this.ganttObj.editSettings.newRowPosition = "Child";
                this.ganttObj.openAddDialog();
            }
        } else if (args.item.text === "Top") {
            this.ganttObj.editSettings.newRowPosition = "Top";
            this.ganttObj.openAddDialog();
        }
        }
    public toolbarClick(args: ClickEventArgs): void {
            if (args.item.id === 'ganttDefault_add') {
                let contextmenuObj: ContextMenu = getInstance(document.getElementById("contextmenu_0"), ContextMenu) as ContextMenu;
                contextmenuObj.open(40, 20);
            }
    };
}




function getInstance(arg0: HTMLElement | null, ContextMenu: any): ContextMenu {
    throw new Error('Function not implemented.');
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { GanttModule,ContextMenuService, ContextMenuItem} from '@syncfusion/ej2-angular-gantt';
import { EditService, SelectionService } from '@syncfusion/ej2-angular-gantt';
import { ContextMenuModule } from '@syncfusion/ej2-angular-navigations';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule, GanttModule,ContextMenuModule 
    ],
    declarations: [AppComponent,],
    bootstrap: [AppComponent],
    providers: [EditService, SelectionService]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);

New row position in React Gantt component

2 Feb 202315 minutes to read

In Gantt, a new row can be added in one of the following positions: Top, Bottom, Above, Below and Child. This position can be specified through the newRowPostion property. We can make use of the toolbarClick event to create a context menu that specifies the position in which the new row is to be added when adding a record through toolbar click.

The following code snippets demonstrate how to achieve this.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, Edit, EditSettingsModel, Selection, Toolbar, ToolbarItem } from '@syncfusion/ej2-react-gantt';
import { ContextMenuComponent } from '@syncfusion/ej2-react-navigations';
import { data } from './datasource';
function  App (){
    const  taskFields = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    duration: 'Duration',
    progress: 'Progress',
    child: 'subtasks'
  };
  const editOptions = {
      allowAdding: true
  };
  let ganttInstance;
  const toolbarOptions = ['Add'];
 let cMenu
 function  toolbarClick(args) {
        if (args.item.id === 'GanttExport_add') {
            cMenu.open(40, 20);
        }
    }
  const menuItems = [
            {
                text: 'Bottom'
            },
            {
                text: 'Above'
            },
            {
                text: 'Below'
            },
            {
                text: 'Child'
            },
            {
                text: 'Top'
            }
        ];
      function  select(args) {
            if (args.item.text === "Bottom") {
            ganttInstance.editSettings.newRowPosition = "Bottom";
            ganttInstance.openAddDialog();
        } else if (args.item.text === "Above") {
            if (ganttInstance.selectedRowIndex == -1) {
                alert("Please select any row");
            } else {
                ganttInstance.editSettings.newRowPosition = "Above";
                ganttInstance.openAddDialog();
            }
        } else if (args.item.text === "Below") {
            if (ganttInstance.selectedRowIndex == -1) {
                alert("Please select any row");
            } else {
                ganttInstance.editSettings.newRowPosition = "Child";
                ganttInstance.openAddDialog();
            }
        } else if (args.item.text === "Child") {
            if (ganttInstance.selectedRowIndex == -1) {
                alert("Please select any row");
            } else {
                ganttInstance.editSettings.newRowPosition = "Child";
                ganttInstance.openAddDialog();
            }
        } else if (args.item.text === "Top") {
            ganttInstance.editSettings.newRowPosition = "Top";
            ganttInstance.openAddDialog();
        }
        }

        return<>
        <ContextMenuComponent id='contextmenu' ref={(scope) => cMenu = scope} items={menuItems} select={select}/>
        <GanttComponent dataSource={data} taskFields={taskFields} allowSelection={true}
        editSettings={editOptions} toolbar={toolbarOptions} toolbarClick={toolbarClick} height = '450px' ref={gantt => ganttInstance = gantt}>
            <Inject services={[Edit, Selection, Toolbar]} />
        </GanttComponent></>
};
ReactDOM.render(<App />, document.getElementById('root'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, Edit, EditSettingsModel, Selection, Toolbar, ToolbarItem } from '@syncfusion/ej2-react-gantt';
import { ContextMenuComponent } from '@syncfusion/ej2-react-navigations';
import { data } from './datasource';
function  App (){
    const  taskFields: any = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    duration: 'Duration',
    progress: 'Progress',
    child: 'subtasks'
  };
  const editOptions: EditSettingsModel = {
      allowAdding: true
  };
  let ganttInstance;
  const toolbarOptions: ToolbarItem[] = ['Add'];
 let cMenu
 function  toolbarClick(args) {
        if (args.item.id === 'GanttExport_add') {
            cMenu.open(40, 20);
        }
    }
  const menuItems = [
            {
                text: 'Bottom'
            },
            {
                text: 'Above'
            },
            {
                text: 'Below'
            },
            {
                text: 'Child'
            },
            {
                text: 'Top'
            }
        ];
      function  select(args) {
            if (args.item.text === "Bottom") {
            ganttInstance.editSettings.newRowPosition = "Bottom";
            ganttInstance.openAddDialog();
        } else if (args.item.text === "Above") {
            if (ganttInstance.selectedRowIndex == -1) {
                alert("Please select any row");
            } else {
                ganttInstance.editSettings.newRowPosition = "Above";
                ganttInstance.openAddDialog();
            }
        } else if (args.item.text === "Below") {
            if (ganttInstance.selectedRowIndex == -1) {
                alert("Please select any row");
            } else {
                ganttInstance.editSettings.newRowPosition = "Child";
                ganttInstance.openAddDialog();
            }
        } else if (args.item.text === "Child") {
            if (ganttInstance.selectedRowIndex == -1) {
                alert("Please select any row");
            } else {
                ganttInstance.editSettings.newRowPosition = "Child";
                ganttInstance.openAddDialog();
            }
        } else if (args.item.text === "Top") {
            ganttInstance.editSettings.newRowPosition = "Top";
            ganttInstance.openAddDialog();
        }
        }

        return<>
        <ContextMenuComponent id='contextmenu' ref={(scope) => cMenu = scope} items={menuItems} select={select}/>
        <GanttComponent dataSource={data} taskFields={taskFields} allowSelection={true}
        editSettings={editOptions} toolbar={toolbarOptions} toolbarClick={toolbarClick} height = '450px' ref={gantt => ganttInstance = gantt}>
            <Inject services={[Edit, Selection, Toolbar]} />
        </GanttComponent></>
};
ReactDOM.render(<App />, document.getElementById('root'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/material.css" rel="stylesheet" type="text/css"/>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
        <div id='root'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>